﻿using Syncfusion.OCRProcessor;
using Syncfusion.Pdf;
using Syncfusion.Pdf.Parsing;
using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Forms;

namespace WFSample
{
    public partial class Form1 : Form
    {
        public Form1()
        {
            InitializeComponent();
        }
        private string tesseractBinariesPath = @"C:\Program Files (x86)\Syncfusion\Essential Studio\15.3.0.26\OCRProcessor\";
        private string tessdataPath = @"C:\Program Files (x86)\Syncfusion\Essential Studio\15.3.0.26\OCRProcessor\Tessdata\";
        private void button1_Click(object sender, EventArgs e)
        {
            //Load the existing PDF document
            PdfLoadedDocument ldoc = new PdfLoadedDocument("../../Data/input.pdf");

            int blankPageCount = 0;

            foreach (PdfLoadedPage lpage in ldoc.Pages)
            {
                if (IsBlankPage(lpage))
                    blankPageCount++;
            }

            ldoc.Close(true);
            MessageBox.Show("Blank page count: " + blankPageCount.ToString());
        }
        private bool IsBlankPage(PdfLoadedPage lpage)
        {
            bool isBlankPage = false;

            //Extract images
            Image[] images = lpage.ExtractImages();

            if (images.Length > 0)
            {
                foreach (Image img in images)
                {
                    if (!PerformOCR(img as Bitmap))
                    {
                        isBlankPage = false;
                        break;
                    }
                    else
                        isBlankPage = true;
                }
            }
            else
            {
                isBlankPage = true;
            }
            return isBlankPage;
        }
        private bool PerformOCR(Bitmap img)
        {
            bool empty = false;
            //Create a new OCR processor
            using (OCRProcessor processor = new OCRProcessor(tesseractBinariesPath))
            {
                //Set language.
                processor.Settings.Language = Languages.English;

                //perform OCR
                string text = processor.PerformOCR(img, tessdataPath);

                if (text == null || text == string.Empty)
                {
                    empty = true;
                }
            }
            return empty;
        }
    }
}
